PROGRAM CRCTEST;        {Tested}

USES ECrc32,EFIO;      { EFIO is only used to display a value in HEX form}

CONST FileName='test.dat';      {Make sure the file exists, and size>0}

VAR F           : File;
    Buffer      : ARRAY[0..2047] OF BYTE; { 2kb buffer, but CalcCRC
                                            can process a Gigabyte buffer}
    BytesRead   : WORD;
    Crc         : CARDINAL;

BEGIN
 CreateCRC32Table(Poly32);              { Generate the CRC table}
 Assign(F,Filename);
 Reset(F,1);
 CRC:=$0FFFFFFFF;                       { Standard start-value}
 REPEAT
  BlockRead(F,Buffer,2048,BytesRead);   { Read a chunk}
  Crc:=CalcCrc(CRC,Buffer,BytesRead);   { calculate a CRC over the chunk}
 UNTIL BytesRead<>2048;                 { Until end-of-file}
 Close(F);
 WrLngHex(InvertCRC(CRC));              { Invert CRC and display}
 Writeln;
END.
